Bug 1013363 - Review Request: libre - SIP protocol library
Review Request: libre - SIP protocol library
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-29 11:49 EDT by Lars Kellogg-Stedman
Modified: 2015-07-21 08:59 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-06-26 09:21:07 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Lars Kellogg-Stedman 2013-09-29 11:49:55 EDT
Spec URL: https://github.com/larsks-packages/libre/raw/review/libre.spec
SRPM URL: https://github.com/larsks-packages/libre/raw/review/libre-0.4.4-3.fc19.src.rpm
Description: Libre is a portable and generic library for real-time communications with async IO support and a complete SIP stack with support for SDP, RTP/RTCP, STUN/TURN/ICE, BFCP and DNS Client.
Fedora Account System Username: larsks

This package is a dependency for baresip, a barebones SIP client that I would like to get packaged for Fedora.
Comment 1 Lars Kellogg-Stedman 2013-09-29 11:54:44 EDT
This is the first time I'm submitting a package to Fedora so I will need a sponsor.

This SRPM has built successfully in Koji:

https://koji.fedoraproject.org/koji/taskinfo?taskID=6001565
Comment 2 Johan Swensson 2013-10-16 16:44:31 EDT
Informal review:

SRPM url is dead

I snatched the SRPM from koji.

$ rpmlint libre-0.4.4-3.fc19.src.rpm 
libre.src: W: spelling-error Summary(en_US) runtime -> run time, run-time, rudiment
libre.src: W: spelling-error %description -l en_US async -> sync, a sync
libre.src: W: spelling-error %description -l en_US runtime -> run time, run-time, rudiment
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

$ rpmlint libre-0.4.4-3.fc19.x86_64.rpm 
libre.x86_64: W: spelling-error Summary(en_US) runtime -> run time, run-time, rudiment
libre.x86_64: W: spelling-error %description -l en_US async -> sync, a sync
libre.x86_64: W: spelling-error %description -l en_US runtime -> run time, run-time, rudiment
libre.x86_64: W: incoherent-version-in-changelog 0.4.4-1 ['0.4.4-3.fc19', '0.4.4-3']
libre.x86_64: W: no-soname /usr/lib64/libre.so
1 packages and 0 specfiles checked; 0 errors, 5 warnings.


From build.log
+ cd re-0.4.4
+ make -j5 LIBDIR=/usr/lib64

You don't seem to use the correct build flags. Have a look at the %{optflags} macro.
Comment 3 Johan Swensson 2013-10-18 16:19:34 EDT
One more comment.

The %{_datadir}/re directory isn't owned by the package.
Comment 4 Michael Schwendt 2013-10-21 11:04:35 EDT
Please keep "Spec URL" and "SRPM URL" in sync:

Spec URL: https://github.com/larsks-packages/libre/raw/review/libre.spec
SRPM URL: https://github.com/larsks-packages/libre/raw/review/libre-0.4.4-5.fc19.src.rpm


The %changelog ought to sum up all changes to the spec file. Doing that also during the review process is a good exercise. It can happen that a reviewer doesn't insist on doing that, however.

https://fedoraproject.org/wiki/Packaging:FrequentlyMadeMistakes

https://fedoraproject.org/wiki/Packaging:Guidelines#Changelogs

https://fedoraproject.org/wiki/Category:Package_Maintainers


> + cd re-0.4.4
> + make -j3 LIBDIR=/usr/lib64
>   CC      build-x86_64/sip/addr.o
>   CC      build-x86_64/sip/auth.o
> ...

In this build output, one cannot see what compiler/linker flags are used. The Makefile runs the commands silently with '@' prefix notation. Patching that out would be highly recommended, so the build.log doesn't hide these details and could be examined any time for current and old builds, too (e.g. as long as it's stored in koji).
Comment 5 Cleber Rosa 2013-12-05 13:10:49 EST
Following is a package review guided/helped by fedora-review.

Please pay the most attention to the following items:

* Differences between spec file in URL and in the SRPM file
* rpmlint warns about versions mismatches (with and without dist)


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[-]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines. Comment: BSD
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Public domain", "Unknown or generated", "zlib/libpng". 235 files have
     unknown license. Detailed output of licensecheck in
     /home/cleber/1013363-libre/licensecheck.txt
[x]: License file installed when any subpackage combination is installed. Comment: COPYING
[?]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 6 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: libre-0.4.4-5.fc19.x86_64.rpm
          libre-devel-0.4.4-5.fc19.x86_64.rpm
          libre-0.4.4-5.fc19.src.rpm
libre.x86_64: W: spelling-error Summary(en_US) runtime -> run time, run-time, rudiment
libre.x86_64: W: spelling-error %description -l en_US async -> sync, a sync
libre.x86_64: W: spelling-error %description -l en_US runtime -> run time, run-time, rudiment
libre.x86_64: W: incoherent-version-in-changelog 0.4.4-1 ['0.4.4-5.fc19', '0.4.4-5']
libre-devel.x86_64: W: spelling-error %description -l en_US async -> sync, a sync
libre-devel.x86_64: W: no-documentation
libre.src: W: spelling-error Summary(en_US) runtime -> run time, run-time, rudiment
libre.src: W: spelling-error %description -l en_US async -> sync, a sync
libre.src: W: spelling-error %description -l en_US runtime -> run time, run-time, rudiment
3 packages and 0 specfiles checked; 0 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libre-devel libre
libre-devel.x86_64: W: spelling-error %description -l en_US async -> sync, a sync
libre-devel.x86_64: W: no-documentation
libre.x86_64: W: spelling-error Summary(en_US) runtime -> run time, run-time, rudiment
libre.x86_64: W: spelling-error %description -l en_US async -> sync, a sync
libre.x86_64: W: spelling-error %description -l en_US runtime -> run time, run-time, rudiment
libre.x86_64: W: incoherent-version-in-changelog 0.4.4-1 ['0.4.4-5.fc19', '0.4.4-5']
2 packages and 0 specfiles checked; 0 errors, 6 warnings.
# echo 'rpmlint-done:'



Requires
--------
libre-devel (rpmlib, GLIBC filtered):
    libre(x86-64)
    libre.so.0.4.4()(64bit)

libre (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libdl.so.2()(64bit)
    libpthread.so.0()(64bit)
    libresolv.so.2()(64bit)
    libssl.so.10()(64bit)
    libssl.so.10(libssl.so.10)(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
libre-devel:
    libre-devel
    libre-devel(x86-64)

libre:
    libre
    libre(x86-64)
    libre.so.0.4.4()(64bit)



Diff spec file in url and in SRPM
---------------------------------
--- /home/cleber/1013363-libre/srpm/libre.spec	2013-11-21 01:59:13.643187100 -0300
+++ /home/cleber/1013363-libre/srpm-unpacked/libre.spec	2013-09-29 22:18:34.000000000 -0300
@@ -64,9 +64,4 @@
 %changelog
 
-* Sun Sep 29 2013 Lars Kellogg-Stedman <lars@redhat.com> 0.4.4-5
-- generate a versioned shared library
-- removed static library from devel package
-- ensure correct ownership of directories
-
 * Fri Sep 27 2013 Lars Kellogg-Stedman <lars@redhat.com> 0.4.4-1
 - initial package


Source checksums
----------------
http://www.creytiv.com/pub/re-0.4.4.tar.gz :
  CHECKSUM(SHA256) this package     : cedc399c2fc4420c5fd81acf9dc629dc7d1aeefab4265439a714fa8a68dc3cfd
  CHECKSUM(SHA256) upstream package : cedc399c2fc4420c5fd81acf9dc629dc7d1aeefab4265439a714fa8a68dc3cfd


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1013363
Buildroot used: fedora-19-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 6 Lars Kellogg-Stedman 2014-06-26 09:21:07 EDT
I've abandoned this, since there was a long discussion on the list regarding the lack of versioned libraries, and I didn't feel like struggling with upstream to fix this issue on multiple libraries.

If someone besides me is interested in this package I am happy to revisit.

Note You need to log in before you can comment on or make changes to this bug.